
/* Chrysalide - Outil d'analyse de fichiers binaires
 * extract.h - prototypes pour l'organisation d'une extraction d'un élément d'une série interne
 *
 * Copyright (C) 2023 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_SCAN_EXPRS_EXTRACT_H
#define _ANALYSIS_SCAN_EXPRS_EXTRACT_H


#include "../expr.h"
#include "../../../common/szstr.h"



#define G_TYPE_SCAN_PENDING_EXTRACTION            g_scan_pending_extraction_get_type()
#define G_SCAN_PENDING_EXTRACTION(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_SCAN_PENDING_EXTRACTION, GScanPendingExtraction))
#define G_IS_SCAN_PENDING_EXTRACTION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_SCAN_PENDING_EXTRACTION))
#define G_SCAN_PENDING_EXTRACTION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_SCAN_PENDING_EXTRACTION, GScanPendingExtractionClass))
#define G_IS_SCAN_PENDING_EXTRACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_SCAN_PENDING_EXTRACTION))
#define G_SCAN_PENDING_EXTRACTION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_SCAN_PENDING_EXTRACTION, GScanPendingExtractionClass))


/* Extraction d'un élément donné au sein d'une série interne (instance) */
typedef struct _GScanPendingExtraction GScanPendingExtraction;

/* Extraction d'un élément donné au sein d'une série interne (classe) */
typedef struct _GScanPendingExtractionClass GScanPendingExtractionClass;


/* Indique le type défini pour une extraction d'élément de série interne. */
GType g_scan_pending_extraction_get_type(void);

/* Organise l'extraction d'un élément d'une série interne. */
GScanExpression *g_scan_pending_extraction_new(const sized_string_t *, GScanExpression *);



#endif  /* _ANALYSIS_SCAN_EXPRS_EXTRACT_H */
