
/* Chrysalide - Outil d'analyse de fichiers binaires
 * bytes-int.h - prototypes internes pour la sauvegarde de correspondances avec des suites d'octets identifiées
 *
 * Copyright (C) 2022 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_SCAN_MATCHES_BYTES_INT_H
#define _ANALYSIS_SCAN_MATCHES_BYTES_INT_H


#include "bytes.h"


#include "../matches-int.h"



/* Correspondances trouvées avec des suite d'octets (instance) */
struct _GScanBytesMatches
{
    GScanMatches parent;                    /* A laisser en premier        */

    GScanContext *context;                  /* Contexte de rattachement    */

    // TODO : if NDEBUG ?
    phys_t content_start;                   /* Point de début du contenu   */
    phys_t content_end;                     /* Point de fin du contenu     */

    match_area_t *areas;                    /* Zones couvertes             */
    size_t count;                           /* Nombre de zones             */

};

/* Correspondances trouvées avec des suite d'octets (classe) */
struct _GScanBytesMatchesClass
{
    GScanMatchesClass parent;               /* A laisser en premier        */

};


/* Met en place une série de correspondances avec des octets. */
bool g_scan_bytes_matches_create(GScanBytesMatches *, GSearchPattern *, GScanContext *);



#endif  /* _ANALYSIS_SCAN_MATCHES_BYTES_INT_H */
